package com.brilliance.isc.funds.fxtlop.service.impl;

import com.brilliance.isc.bo.Cbb;
import com.brilliance.isc.bo.Cur;
import com.brilliance.isc.bo.Fxd;
import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.bo.model.Fxtp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.isc.funds.fxtlop.service.FxtpService;
import com.brilliance.isc.mda.dao.CurMapper;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Objects;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Service
public class FxtpServiceImpl implements FxtpService {

    @Resource
    private XrtmodService xrtmodService;

    @Resource
    private CurMapper curMapper;

    @Override
    public void initFxtp(FxtlopStoreBo fxtlopStoreBo) {

    }

    @Override
    public void defaultFxtp(FxtlopStoreBo fxtlopStoreBo) {
        String frame = SettleContext.getTransName();
        if (MdaUtils.compareTo(frame, "FXTSOP") != 0 && MdaUtils.compareTo(frame, "FXTBOP") != 0 && MdaUtils.compareTo(frame, "FXTEOP") != 0) {
//            //! Read USRGET\\USR according to USR.
//            if( MdaUtils.compareTo(fxtlopStoreBo.getUsrget().getUsr().getExtkey(),fxtlopStoreBo.getFxdgrp().getRec().getUsr()) != 0 )
//            {
//                fxtlopStoreBo.getUsrget().recReadRecordbyExtkey ( fxtlopStoreBo.getFxdgrp().getRec().getUsr() );
//                if( MdaUtils.compareTo(fxtlopStoreBo.getPansta(),PanStaShow) != 0 )
//                {
//                    if( ctx.getErrorCode() == tdOdbcNotFound )
//                    {
//                        Dynamic.sysWarningSet( SYSWRNTypeWarning, Strings.getText(MdaUtils.getI18NString("fxtp","CT000003"),fxtlopStoreBo.getFxdgrp().getRec().getUsr()), "USRINVALID" );
//                    }
//                    else
//                    {
//                        ctx.reraise();
//                        Dynamic.sysWarningSet( SYSWRNTypeWarning, "", "USRINVALID" );
//                    }
//                }
//                else
//                {
//                    if( ctx.getErrorCode() != tdOdbcNotFound )
//                    {
//                        ctx.reraise();
//                    }
//                }
//            }
//            Dynamic.trnModCopyModFlag( MdaDriver.getDatafield(fxtlopStoreBo.getFxdgrp().getRec(),"usr"), MdaDriver.getDatafield(fxtlopStoreBo.getUsrget().getUsr(),"extkey") );
//        }
//        if( Platform.checkUsrBranch("1") || MdaUtils.compareTo(frame,"FXTSOP") == 0 || MdaUtils.compareTo(frame,"FXTBOP") == 0 || MdaUtils.compareTo(frame,"FXTEOP") == 0 )
//        {
//            if( MdaUtils.compareTo(fxtlopStoreBo.getUsrget().getUsr().getExtkey(),fxtlopStoreBo.getFxdgrp().getRec().getOwnusr()) != 0 )
//            {
//                fxtlopStoreBo.getUsrget().recReadRecordbyExtkey ( fxtlopStoreBo.getFxdgrp().getRec().getOwnusr() );
//                if( MdaUtils.compareTo(fxtlopStoreBo.getPansta(),PanStaShow) != 0 )
//                {
//                    if( ctx.getErrorCode() == tdOdbcNotFound )
//                    {
//                        Dynamic.sysWarningSet( SYSWRNTypeWarning, Strings.getText(MdaUtils.getI18NString("fxtp","CT000004"),fxtlopStoreBo.getFxdgrp().getRec().getOwnusr()), "USRINVALID" );
//                    }
//                    else
//                    {
//                        ctx.reraise();
//                        Dynamic.sysWarningSet( SYSWRNTypeWarning, "", "USRINVALID" );
//                    }
//                }
//                else
//                {
//                    if( ctx.getErrorCode() != tdOdbcNotFound )
//                    {
//                        ctx.reraise();
//                    }
//                }
//            }
//            Dynamic.trnModCopyModFlag( MdaDriver.getDatafield(fxtlopStoreBo.getFxdgrp().getRec(),"ownusr"), MdaDriver.getDatafield(fxtlopStoreBo.getUsrget().getUsr(),"extkey") );
        }
    }


    /**
     * source:fxtp.0013.script
     */
    @Override
//    @Default(value={"fxdgrp.cbs.max.amt","fxdgrp.cbs.nom1.amt"},order=1100)
    public void defaultCalculateN1100(Fxdgrp fxdgrp, Fxtp fxtp) {
        fxdgrp.reset();
        fxtp.reset();
        Fxd rec = fxdgrp.getRec();
        Cbb max = fxdgrp.getCbs().getMax();
        Cbb nom1 = fxdgrp.getCbs().getNom1();
        int bas = 0;
        String sql = NULLSTR;
        BigDecimal baseunit = null;
        if (MdaUtils.compareTo(fxtp.getCalflg(), "") == 0) {
            if (MdaUtils.compareTo(fxtp.getFrgchk(), "X") == 0) { //换算外币
                if (!MdaUtils.isEmpty(rec.getRat()) && !MdaUtils.isEmpty(nom1.getCur())) {
                    if (Strings.pos("-RUB-JPY-KRW-", max.getCur()) > 0 && Strings.pos("-FXTLOP-FXTLCM-FXTLCN-", SettleContext.getTransName()) > 0) {
                        if (MdaUtils.compareTo(rec.getRat(), 0) > 0) {
                            nom1.setAmt(xrtmodService.amtRnd(Decimals.div(max.getAmt(), rec.getRat()), nom1.getCur()));
                        }
                    } else {
                        nom1.setAmt(xrtmodService.amtRnd(Decimals.mul(max.getAmt(), rec.getRat()), nom1.getCur()));
                        Cur queryCur = new Cur();
                        queryCur.setCod(max.getCur());
                        Cur cur = curMapper.selectByCod(queryCur);
//                        sql = "SELECT BAS FROM CUR WHERE COD = '" + fxdgrp.getCbs().getMax().getCur() + "'";
                        if (Objects.nonNull(cur)) {
                            bas = cur.getBas();
                        } else {
                            bas = 1;
                        }
                        baseunit = xrtmodService.crossRatebas(max.getCur(), nom1.getCur());
                        if (MdaUtils.compareTo(baseunit, bas) >= 0) {
                            nom1.setAmt(Decimals.div(nom1.getAmt(), bas));
                        } else {
                            if (MdaUtils.compareTo(baseunit, 1) < 0) {
                                nom1.setAmt(Decimals.div(nom1.getAmt(), bas));
                            } else {
                                nom1.setAmt(Decimals.div(nom1.getAmt(), baseunit));
                            }
                        }
                    }
                } else {
                    nom1.setAmt(new BigDecimal(0));
                }
            } else {
                if (MdaUtils.compareTo(fxtp.getCnychk(), "X") == 0) {   //换算人民币
                    if (!MdaUtils.isEmpty(rec.getRat()) && !MdaUtils.isEmpty(max.getCur())) {
                        max.setAmt(xrtmodService.amtRnd(Decimals.div(nom1.getAmt(), rec.getRat()), max.getCur()));
                        Cur queryCur = new Cur();
                        queryCur.setCod(max.getCur());
                        Cur cur = curMapper.selectByCod(queryCur);
//                        sql = "SELECT BAS FROM CUR WHERE COD = '" + fxdgrp.getCbs().getMax().getCur() + "'";
                        if (Objects.nonNull(cur)) {
                            bas = cur.getBas();
                        } else {
                            bas = 1;
                        }
                        max.setAmt(Decimals.mul(max.getAmt(), bas));
                    } else {
                        max.setAmt(new BigDecimal(0));
                    }
                }
            }
        } else {
            if (!MdaUtils.isEmpty(rec.getRat()) && !MdaUtils.isEmpty(max.getCur())) {
                max.setAmt(xrtmodService.amtRnd(Decimals.div(nom1.getAmt(), rec.getRat()), max.getCur()));
                Cur queryCur = new Cur();
                queryCur.setCod(max.getCur());
                Cur cur = curMapper.selectByCod(queryCur);
//                        sql = "SELECT BAS FROM CUR WHERE COD = '" + fxdgrp.getCbs().getMax().getCur() + "'";
                if (Objects.nonNull(cur)) {
                    bas = cur.getBas();
                } else {
                    bas = 1;
                }
                nom1.setAmt(Decimals.mul(nom1.getAmt(), bas));
            } else {
                max.setAmt(new BigDecimal(0));
            }
        }
    }
}
